
/********************************************************************
* NAME:                                                             *
*                                                                   *
* PURPOSE:                                                          *
*                                                                   *
* GLOBAL VARIABLES:                                                 *
*                                                                   *
* Variable:                                                         *
*                                                                   *
* Type:                                                             *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* DEVELOPMENT HISTORY:                                              *
*                                                                   *
* Date:                                                             *
*                                                                   *
* Author:                                                           *
*                                                                   *
* Change Id:                                                        *
*                                                                   *
* Release:                                                          *
*                                                                   *
* Description of change:                                            *
*                                                                   *
*********************************************************************/

#ifndef __fls1_pub_h
#define __fls1_pub_h

#ifdef __FROM_CPP__
  #define __IMPORT_TYPE extern "C" 
#else
  #define __IMPORT_TYPE
#endif

#ifdef WIN32
  #ifdef __BUILDING_THE_DLL
    #define __EXPORT_TYPE __declspec(dllexport)
  //__export
  #else
    #define __EXPORT_TYPE __declspec(dllimport)
  #endif
#else
  // LINUX
  #define __EXPORT_TYPE
#endif

#define ENGINE_BUILD 18

typedef enum {
              FE_OK = 0,
              FE_CANT_READWRITE             = 0x80000002,
              FE_NOT_IMPLEMENTED            = 0x80000004,
              FE_PHONE_NOT_RESPOND_1        = 0x80000082,
              FE_PHONE_NOT_RESPOND_2        = 0x80000083,
              FE_PHONE_NOT_RESPOND_3        = 0x80000096,
              FE_PHONE_NOT_RESPOND_4        = 0x80000095,
              FE_PHONE_NOT_RESPOND_5        = 0x80000085,
              FE_PHONE_NOT_RESPOND_6        = 0x80000089,
              FE_PHONE_NOT_RESPOND_7        = 0x80000088,
              FE_PHONE_NOT_RESPOND_8        = 0x8000008A,
              FE_PHONE_NOT_RESPOND_9        = 0x80000081,
              FE_INVALID_DATA_FROM_PHONE    = 0x80000092,
              FE_INVALID_RESPONSE_FROM_SDA2 = 0x80000091,
              FE_INVALID_RESPONSE_FROM_SDA  = 0x80000094,
              FE_FILE_NOT_FOUND             = 0x30,
              FE_INVALID_FLASHID            = 0x31,
              FE_INVALID_CHECKSUM           = 0x34,
              FE_INVALID_PROGRAMMING_STATUS = 0x36,
              FE_INVALID_STATUS_CHECKSUM    = 0x37,
              FE_MESSAGEID_NOT_FOUND        = 207,
              FE_TAG_NOT_FOUND              = 219,
              FE_INVALID_MESSAGE_ID         = 0x35,
              FE_NO_ALGOCODE                = 0x18,
              FE_INVALID_MCU_VERSION        = 0x1001,
              FE_INVALID_LPT_PORT           ,
              FE_CANT_OPEN_COM_PORT         ,
              FE_SEEK_ERROR                 ,
              FE_INVALID_FILEHEADER         ,
              FE_WRITE_ERROR                ,
              FE_INVALID_COMMAND            ,
              FE_TOO_MANY_COMMANDS          ,
              FE_TOO_MANY_ARGUMENTS         ,
              FE_CANT_EXECUTE_MBUS_CMD      ,
              FE_CANT_ERASE                 ,
              FE_EMUFILE_NOT_FOUND          ,
              FE_CANT_FIND_PPM              ,
              FE_CANT_ADD_BLOCK             ,
              FE_CANT_FIND_VERSION          ,
              FE_CANT_FIND_MCU              ,
              FE_INVALID_MCU_PARAMBLOCK_PTR ,
              FE_INVALID_PMM_ENTRY_DATASIZE ,
              FE_INVALID_PMM_ENTRY          ,
              FE_INVALID_FLASH_SIZE         ,
              FE_CANT_GET_MCU_VERSION       ,
              FE_CANT_CREATE_FILE           ,
              FE_INVALID_STARTADDR          ,
              FE_INVALID_FILENAME           ,
              FE_CANT_WRITE_HEADER          ,
              FE_CANT_READ_HEADER           ,
              FE_INVALID_EXTENSION          ,
              FE_INVALID_FILESIZE           ,
              FE_INVALID_FILE_FORMAT        ,
              FE_INVALID_COM_PORT           ,
              FE_NOT_SUPPORTED_FLASHID      ,
              FE_CANT_INIT_PORTDRIVER       ,
              FE_INVALID_ALGOCODE           ,
              FE_INVALID_DIRTYPE            ,
              FE_INVALID_STATE              ,
             } eFLASH_ERROR;


typedef enum
{
 REDIRECTION_TYPE_NONE = 0,
 REDIRECTION_TYPE_REDIRECT_TO_FILE = 1,
 REDIRECTION_TYPE_SAVE_TO_FILE = 2,
} eREDIRECTION_TYPE;


#define UINT32_FORMAT "%08X"

#define FLASH_FLS_EXTENSION "FLS"
#define FLASH_KNK_EXTENSION "KNK"

#define KNK_EXTENSION_ID 0x4B4E4B2E /* .KNK */
#define FLS_EXTENSION_ID 0x534C462E /* .FLS */

#define FLASH_NMP_LEN 8

typedef enum 
{
 DEVICE_STATE_NONE = 0,
 DEVICE_STATE_INITIALIZED,
 DEVICE_STATE_BOOTSTRAP_RUNNING,
 DEVICE_STATE_ALGOCODE_RUNNING,
 DEVICE_STATE_PPM_ANALYZED,
 DEVICE_STATE_PHONE_ANALYZED
} eDEVICE_STATE;

typedef enum
{
  FLASH_DELAY_TYPE_LOOP,
  FLASH_DELAY_TYPE_RDTSC
} eFLASH_DELAY_TYPE;

typedef enum
{
 FLASH_DIRECTORY_CFG,
 FLASH_DIRECTORY_LOADER
} eFLASH_DIRECTORY;

typedef struct 
{
  UINT32 U32delay1; // +0
  UINT32 U32delay2; // +4
  UINT32 U32delay3; // +8
  UINT32 U32delay4; // +12
  UINT32 U32delay5; // +16
  UINT32 U32delay6; // +20
  UINT32 U32delay7; // strictly for DirectWaitForEdge
  UINT32 U32delay8; // strictly for ComWaitForEdge
  UINT32 U32delay9;
} tFLS1_DELAYBLOCK;

typedef struct
{
  UINT32 U32address;
  UINT8 U8expected;
  UINT8 U8contains;
} tFLASH_STATUS;

typedef enum 
{
  FILE_TYPE_DONT_CARE = 0,
  FILE_TYPE_PARTIAL = 1,
  FILE_TYPE_FULL
} eFILE_TYPE; 

typedef struct 
{
  UINT32 U32id;
  UINT32 U32startaddr;
  UINT32 filetype;
  UINT32 U32checksum;
} tFILE_HEADER;

#define MBUS_MAX_FRAME_LEN 32

#define MBUS_MAX_CMD_NAME_LEN 32

typedef struct 
{
  UINT8 AU8name[MBUS_MAX_CMD_NAME_LEN];
  UINT8 U8messagetype;
  UINT8 AU8frame[MBUS_MAX_FRAME_LEN];
  UINT8 U8framesize;
  UINT8 U8replyshift;
} tMBUSCMD;

typedef enum
{
  MBUS_RESET_TYPE_NONE = 0,
  MBUS_RESET_TYPE_PHONE = 1,
  MBUS_RESET_TYPE_UIF,
  MBUS_RESET_TYPE_SCM,
  MBUS_RESET_TYPE_DEV,
  MBUS_RESET_TYPE_FACTORY,
  MBUS_RESET_TYPE_ALL
} eMBUS_RESET_TYPE;

typedef struct
{
 UINT16 U16manuid;
 UINT16 U16devid;
} tFLS1_FLASHID;

#define FLS1_NUM_FLASHIDS 2

typedef struct 
{
  UINT8 U8asicid;
  UINT8 U8configid[8];
  UINT16 U16mcuchecksum;
  UINT8 U8projspec[16];
  UINT8 U8spare[8];
  UINT8 mcusw[100];
  tFLS1_FLASHID flashid[FLS1_NUM_FLASHIDS];
  UINT8 U8checksum;
} tFLS1_CONFIGURATIONRESPONSE_DCT3;

typedef struct
{
  tFLS1_FLASHID flashid;
  UINT8 U8dummy1;
  UINT8 U8dummy2;
  UINT8 U8dummy3[6];
  UINT16 U16dummy4;
  UINT16 U16dummy5;
} tFLS1_ALGOENTRY;

#define FLASH_MAX_EEPROM_CHECKSUMS 2

#define FLASH_EEPROM_IMEI_SIZE 6
#define FLASH_EEPROM_SECCODE_SIZE 3
#define FLASH_PMM_SECCODE_SIZE 6 /* max 5 character + \0 */

typedef struct {
                UINT8 IMEI[FLASH_EEPROM_IMEI_SIZE];
                UINT8 secIMEI[FLASH_EEPROM_IMEI_SIZE];
                UINT16 U16checksum[FLASH_MAX_EEPROM_CHECKSUMS];
                UINT8 securitycode[FLASH_EEPROM_SECCODE_SIZE];
               } tFLASH_EEPROM_INFO;

#define FLASH_MAX_BLOCKS 16
#define FLASH_MAX_PMM_BLOCKS 512

typedef struct {
                UINT32 U32start;
                UINT32 U32end;
               } tFLASH_BLOCK;

typedef struct {
                UINT8 U8num_of_blocks;
                tFLASH_BLOCK block[FLASH_MAX_BLOCKS];
               } tFLASH_BLOCKS;

typedef struct {
                tFLASH_EEPROM_INFO block[FLASH_MAX_BLOCKS];
                } tFLASH_EEPROM_INFO_BLOCKS;

typedef enum {
              FLASH_PMM_ENTRY_STATUS_UNKNOWN = 0,
              FLASH_PMM_ENTRY_STATUS_ENABLED,
              FLASH_PMM_ENTRY_STATUS_DISABLED
             } eFLASH_PMM_ENTRY_STATUS;

typedef struct {
                 eFLASH_PMM_ENTRY_STATUS status;
                 UINT32 U32start;
                 UINT32 U32end; 
                 UINT8 U8id;
                 UINT16 U16datachecksum;
                 UINT16 U16datalength;
               } tFLASH_PMM_INFO;

typedef struct {
                UINT16 U16num_of_entries;
                tFLASH_PMM_INFO entry[FLASH_MAX_PMM_BLOCKS];
                } tFLASH_PMM_INFO_BLOCK;

typedef struct {
                tFLASH_PMM_INFO_BLOCK block[FLASH_MAX_BLOCKS];
                } tFLASH_PMM_INFO_BLOCKS;

#define FLASH_MAX_MSSW_LEN 6

typedef struct {
                char MSSW[FLASH_MAX_MSSW_LEN];
                char NMP[FLASH_MAX_MSSW_LEN];
                SINT32 S32MCUversion;
                char Clanguage_pack;
                BOOL BhiddenMCUblock;
                UINT32 U32MCU2base;
                UINT32 U32infobase;
                UINT16 U16mcuchecksum;
                UINT32 U32ppmchecksum[FLASH_MAX_BLOCKS];
                UINT32 U32fchk;
                UINT32 U32endofppm;
                UINT8 U8detectedfval1;                
                UINT8 U8detectedfval2;
                tFLS1_CONFIGURATIONRESPONSE_DCT3 config;

                tFLASH_EEPROM_INFO_BLOCKS eeprom_info_blocks;
                tFLASH_PMM_INFO_BLOCKS pmm_info_blocks;
                tFLASH_BLOCK ppm_header_block;
                tFLASH_BLOCKS mcu_blocks;
                tFLASH_BLOCKS ppm_blocks;
                tFLASH_BLOCKS pmm_blocks;
                tFLASH_BLOCKS eeprom_blocks;
               } tFLASH_PHONE_INFO;

typedef void (*pLogCallout)(char *logstr,BOOL Biserror, BOOL Bshowaserror);
typedef void (*pGaugeInit)(UINT32 U32startaddr,UINT32 U32endaddr);
typedef void (*pGaugeDone)(void);
typedef void (*pGaugeUpdate)(UINT32 U32addr);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetAutoAlias(BOOL Bval);
typedef void (*pSetAutoAlias)(BOOL Bval);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GetAutoAlias(void);
typedef BOOL (*pGetAutoAlias)(void);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetRedirection(eREDIRECTION_TYPE redirecttype);
typedef void (*pSetRedirection)(eREDIRECTION_TYPE redirecttype);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetDebugLevel(eDEBUG_LEVEL level);
typedef void (*pSetDebugLevel)(eDEBUG_LEVEL level);

__IMPORT_TYPE eDEBUG_LEVEL __EXPORT_TYPE FLS1_GetDebugLevel(void);
typedef eDEBUG_LEVEL (*pGetDebugLevel)(void);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_ConfigurateBootstrapDCT3(UINT8 U8fval1,UINT8 *pAU8buffer,UINT16 U16size);
typedef void (*pConfigurateBootstrapDCT3)(UINT8 U8fval1,UINT8 *pAU8buffer,UINT16 U16size);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GetFlashParameters(char *NMP, UINT8 *pU8fval1, UINT8 *pU8fval2, char *bloader);
typedef BOOL (*pGetFlashParameters)(char *NMP, UINT8 *pU8fval1, UINT8 *pU8fval2, char *bloader);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GetFlashID(tFLS1_FLASHID *pflashid,tFLS1_FLASHID *pnewflashid,UINT8 U8length);
typedef BOOL (*pGetFlashID)(tFLS1_FLASHID *pflashid,tFLS1_FLASHID *pnewflashid,UINT8 U8length);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GetFlashSize(tFLS1_FLASHID *pflashid,UINT8 U8length,UINT8 *pU8size);
typedef BOOL (*pGetFlashSize)(tFLS1_FLASHID *pflashid,UINT8 U8length,UINT8 *pU8size);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_FindModel(BOOL Bfromphone,void *phoneram,char *MSSW,SINT32 *S32version);
typedef BOOL (*pFindModel)(BOOL Bfromphone,void *phoneram,char *MSSW,SINT32 *S32version);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralReceiveConfigurationResponseDCT3(UINT16 U16baseport,tFLS1_DELAYBLOCK *pdelayblock,tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);
typedef BOOL (*pGeneralReceiveConfigurationResponseDCT3)(UINT16 U16baseport,tFLS1_DELAYBLOCK *pdelayblock,tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ReceiveConfigurationResponseDCT3(tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);
typedef BOOL (*pReceiveConfigurationResponseDCT3)(tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralSendBootstrapDCT3(UINT16 U16baseport,
                                                               char *bootstrapname,
                                                               UINT8 U8fval1,
                                                               UINT32 U32retrycount,
                                                               UINT32 U32delay5,
                                                               UINT32 U32delay6,
                                                               tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);
typedef BOOL (*pGeneralSendBootstrapDCT3)(UINT16 U16baseport,
                                          char *bootstrapname,
                                          UINT8 U8fval1,
                                          UINT32 U32retrycount,
                                          UINT32 U32delay5,
                                          UINT32 U32delay6,
                                          tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SendBootstrapDCT3(char *bootstrapname,
                                                        UINT8 U8fval1,
                                                        UINT32 U32retrycount,
                                                        tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);
typedef BOOL (*pSendBootstrapDCT3)(char *bootstrapname,
                                   UINT8 U8fval1,
                                   UINT32 U32retrycount,
                                   tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralSendAlgoCodeDCT3(UINT16 U16baseport,
                                                              char *algocodename,
                                                              UINT8 U8fval1,
                                                              UINT8 U8fval2,
                                                              tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration,
                                                              tFLS1_ALGOENTRY *pfoundalgoentry,
                                                              UINT32 U32delay5,
                                                              UINT32 U32delay6);

typedef BOOL (*pGeneralSendAlgoCodeDCT3)(UINT16 U16baseport,
                                         char *algocodename,
                                         UINT8 U8fval1,
                                         UINT8 U8fval2,
                                         tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration,
                                         tFLS1_ALGOENTRY *pfoundalgoentry,
                                         UINT32 U32delay5,
                                         UINT32 U32delay6);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SendAlgoCodeDCT3(char *algocodename,
                                                       UINT8 U8fval1,
                                                       UINT8 U8fval2,
                                                       tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration,
                                                       tFLS1_ALGOENTRY *pfoundalgoentry);
typedef BOOL (*pSendAlgoCodeDCT3)(char *algocodename,
                                  UINT8 U8fval1,
                                  UINT8 U8fval2,
                                  tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration,
                                  tFLS1_ALGOENTRY *pfoundalgoentry);

/** sendcodedct3 */
__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SendCodeDCT3(UINT8 *code,
							size_t codesize,
							tFLS1_DELAYBLOCK *delayblock);

typedef BOOL (*pSendCodeDCT3)(UINT8 *code,
				size_t codesize,
				tFLS1_DELAYBLOCK *delayblock);


__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_PreparePhone(char *NMP, 
                                                   UINT32 U32retrycount);

typedef BOOL (*pPreparePhone)(char *NMP, 
                              UINT32 U32retrycount);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralProgrammingStatus(UINT16 U16baseport);
typedef BOOL (*pGeneralProgrammingStatus)(UINT16);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ProgrammingStatus(void);
typedef BOOL (*pProgrammingStatus)(void);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralMCURestart(UINT16 U16baseport);
typedef BOOL (*pGeneralMCURestart)(UINT16 U16baseport);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_MCURestart(void);
typedef BOOL (*pMCURestart)(void);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralReadConfigurationDCT3(UINT16 U16baseport, tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);
typedef BOOL (*pGeneralReadConfigurationDCT3)(UINT16 U16baseport, tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ReadConfigurationDCT3(tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);
typedef BOOL (*pReadConfigurationDCT3)(tFLS1_CONFIGURATIONRESPONSE_DCT3 *configuration);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_Read(UINT32 U32startaddr,UINT32 U32count,UINT8 *pAU8buffer);
typedef BOOL (*pRead)(UINT32 U32startaddr,UINT32 U32count,UINT8 *pAU8buffer);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_Erase(UINT32 U32startaddr,UINT32 U32count);
typedef BOOL (*pErase)(UINT32 U32startaddr,UINT32 U32count);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_EraseAll(void);
typedef BOOL (*pEraseAll)(void);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_Write(UINT32 U32startaddr,UINT32 U32count,UINT8 *pAU8buffer);
typedef BOOL (*pWrite)(UINT32 U32startaddr,UINT32 U32count,UINT8 *pAU8buffer);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ReadLarge(UINT32 U32startaddr,UINT32 U32count,char *flashfile,BOOL Bbinary);
typedef BOOL (*pReadLarge)(UINT32 U32startaddr,UINT32 U32count,char *flashfile,BOOL Bbinary);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_EraseLarge(UINT32 U32startaddr,UINT32 U32endaddr);
typedef BOOL (*pEraseLarge)(UINT32 U32startaddr,UINT32 U32endaddr);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_WriteLarge(UINT32 U32extensionid,char *flashfile,UINT32 U32startfile,UINT32 U32countfile,UINT32 U32givenstartaddr,BOOL Bbinary);
typedef BOOL (*pWriteLarge)(UINT32 U32extensionid,char *flashfile,UINT32 U32startfile,UINT32 U32countfile,UINT32 U32givenstartaddr,BOOL Bbinary);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_Initialize(eDEBUG_LEVEL debug_level, pGaugeInit gaugeinit, pGaugeDone gaugedone, pGaugeUpdate gaugeupdate, pLogCallout logcallout, eREDIRECTION_TYPE redicetiontype, char *logfile, eFLASH_DELAY_TYPE delaytype, UINT32 U32basedelay, UINT8 U8lptport, UINT8 U8comport, UINT32 U32comdelay, BOOL Bsafeflash);
typedef BOOL (*pInitialize)(eDEBUG_LEVEL debug_level, pGaugeInit gaugeinit, pGaugeDone gaugedone, pGaugeUpdate gaugeupdate, pLogCallout logcallout, eREDIRECTION_TYPE redicetiontype, char *logfile, eFLASH_DELAY_TYPE delaytype, UINT32 U32basedelay, UINT8 U8lptport, UINT8 U8comport, UINT32 U32comdelay, BOOL Bsafeflash);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GetMCUVersion(SINT32 *S32MCUversion, BOOL Bneedflasher, BOOL Bneedmbus);
typedef BOOL (*pGetMCUVersion)(SINT32 *S32MCUversion, BOOL Bneedflasher, BOOL Bneedmbus);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_CheckHiddenMCUBlock(SINT32 S32start,SINT32 *S32end);
typedef BOOL (*pCheckHiddenMCUBlock)(SINT32 S32start,SINT32 *S32end);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_AnalyzeMCU(tFLASH_PHONE_INFO *phone_info,char *MSSW,SINT32 *S32version);
typedef BOOL (*pAnalyzeMCU)(tFLASH_PHONE_INFO *phone_info,char *MSSW,SINT32 *S32version);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_AnalyzePPM(tFLASH_PHONE_INFO *phone_info, BOOL Bneedfchk);
typedef BOOL (*pAnalyzePPM)(tFLASH_PHONE_INFO *phone_info, BOOL Bneedfchk);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_AnalyzeEEPROM(tFLASH_PHONE_INFO *phone_info);
typedef BOOL (*pAnalyzeEEPROM)(tFLASH_PHONE_INFO *phone_info);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_CheckIMEI(tFLASH_PHONE_INFO *phone_info,BOOL Bfix,BOOL *Bchanged);
typedef BOOL (*pCheckIMEI)(tFLASH_PHONE_INFO *phone_info,BOOL Bfix,BOOL *Bchanged);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_CheckSecurityCode(tFLASH_PHONE_INFO *phone_info,BOOL Bfix,BOOL *Bchanged);
typedef BOOL (*pCheckSecurityCode)(tFLASH_PHONE_INFO *phone_info,BOOL Bfix,BOOL *Bchanged);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ClearSecurityCodeCounter(tFLASH_PHONE_INFO *phone_info,BOOL *Bchanged);
typedef BOOL (*pClearSecurityCodeCounter)(tFLASH_PHONE_INFO *phone_info,BOOL *Bchanged);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_AnalyzePMM(tFLASH_PHONE_INFO *phone_info);
typedef BOOL (*pAnalyzePMM)(tFLASH_PHONE_INFO *phone_info);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_Analyze(tFLASH_PHONE_INFO *phone_info);
typedef BOOL (*pAnalyze)(tFLASH_PHONE_INFO *phone_info);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GetPhoneInfo(tFLASH_PHONE_INFO *phone_info,char *MSSW,BOOL Banalyze, BOOL Bneedflasher, BOOL Bneedmbus, BOOL Bneedfchk);
typedef BOOL (*pGetPhoneInfo)(tFLASH_PHONE_INFO *phone_info,char *MSSW,BOOL Banalyze, BOOL Bneedflasher, BOOL Bneedmbus, BOOL Bneedfchk);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SavePhoneInfo(tFLASH_PHONE_INFO *phone_info,char *logfile, BOOL Bneedfchk);
typedef BOOL (*pSavePhoneInfo)(tFLASH_PHONE_INFO *phone_info,char *logfile, BOOL Bneedfchk);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SaveSecurityPhoneInfo(char *logfile);
typedef BOOL (*pSaveSecurityPhoneInfo)(char *logfile);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_CheckPMMChecksums(tFLASH_PHONE_INFO *phone_info,BOOL Bfix);
typedef BOOL (*pCheckPMMChecksums)(tFLASH_PHONE_INFO *phone_info,BOOL Bfix);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_CheckChecksums(tFLASH_PHONE_INFO *phone_info,BOOL Bfix);
typedef BOOL (*pCheckChecksums)(tFLASH_PHONE_INFO *phone_info,BOOL Bfix);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SaveBlock(tFLASH_BLOCK *block,char *basepath,char *extrainfo,BOOL Bbinary);
typedef BOOL (*pSaveBlock)(tFLASH_BLOCK *block,char *basepath,char *extrainfo,BOOL Bbinary);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SaveBlocks(tFLASH_BLOCKS *flash_block,char *basepath,char *mask,UINT8 U8num_of_args,UINT32 *U32numarg,BOOL Bbinary);
typedef BOOL (*pSaveBlocks)(tFLASH_BLOCKS *flash_block,char *basepath,char *mask,UINT8 U8num_of_args,UINT32 *U32numarg,BOOL Bbinary);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SetEmulation(char *filename,BOOL Bbinaryemulate);
typedef BOOL (*pSetEmulation)(char *filename,BOOL Bbinaryemulate);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_DetectSupportedAlgoCodes(char *algocodename,UINT8 *pU8numentries,tFLS1_FLASHID flashids[]);
typedef BOOL (*pDetectSupportedAlgoCodes)(char *algocodename,UINT8 *pU8numentries,tFLS1_FLASHID flashids[]);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_CreateFlashIDList(void);
typedef BOOL (*pCreateFlashIDList)(void);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SearchAlgoCode(char *conversion_file,BOOL Brecreateidlist,UINT16 U16manuid,UINT16 U16devid,char *algocodename, BOOL *Bnofile);
typedef BOOL (*pSearchAlgoCode)(char *conversion_file,BOOL Brecreateidlist,UINT16 U16manuid,UINT16 U16devid,char *algocodename, BOOL *Bnofile);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_Terminate(void);
typedef void (*pTerminate)(void);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetForcedFlashSize(UINT8 U8forcedflashsize);
typedef void (*pSetForcedFlashSize)(UINT8 U8forcedflashsize);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SetDirectory(eFLASH_DIRECTORY dirtype,char *pathname);
typedef BOOL (*pSetDirectory)(eFLASH_DIRECTORY dirtype,char *pathname);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetSkipErase(BOOL SetSkipErase);
typedef void (*pSetSkipErase)(BOOL SetSkipErase);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_GetDefaultTimes(tFLS1_DELAYBLOCK *pdelayblock);
typedef void (*pGetDefaultTimes)(tFLS1_DELAYBLOCK *pdelayblock);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetDefaultTimes(tFLS1_DELAYBLOCK *pdelayblock);
typedef void (*pSetDefaultTimes)(tFLS1_DELAYBLOCK *pdelayblock);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_GeneralSetIdleState(UINT16 U16baseport, UINT32 U32mode);
typedef void (*pGeneralSetIdleState)(UINT16 U16baseport, UINT32 U32mode);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetIdleState(UINT32 U32mode);
typedef void (*pSetIdleState)(UINT32 U32mode);

__IMPORT_TYPE UINT8 __EXPORT_TYPE FLS1_GeneralGetSDA(UINT16 U16baseport);
typedef UINT8 (*pGeneralGetSDA)(UINT16 U16baseport);

__IMPORT_TYPE UINT8 __EXPORT_TYPE FLS1_GetSDA(void);
typedef UINT8 (*pGetSDA)(void);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralWaitForEdge(UINT16 U16baseport, BOOL Bishigh, UINT32 U32retrycount);
typedef BOOL (*pGeneralWaitForEdge)(UINT16 U16baseport, BOOL Bishigh, UINT32 U32retrycount);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_WaitForEdge(BOOL Bishigh, UINT32 U32retrycount);
typedef BOOL (*pWaitForEdge)(BOOL Bishigh, UINT32 U32retrycount);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralReceiveFromPhone(UINT16 U16baseport, UINT8 *pAU8buffer, UINT32 U32size, UINT32 U32cmd, tFLS1_DELAYBLOCK *pdelayblock);
typedef BOOL (*pGeneralReceiveFromPhone)(UINT16 U16baseport, UINT8 *pAU8buffer, UINT32 U32size, UINT32 U32cmd, tFLS1_DELAYBLOCK *pdelayblock);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ReceiveFromPhone(UINT8 *pAU8buffer, UINT32 U32size, UINT32 U32cmd, tFLS1_DELAYBLOCK *pdelayblock);
typedef BOOL (*pReceiveFromPhone)(UINT8 *pAU8buffer, UINT32 U32size, UINT32 U32cmd, tFLS1_DELAYBLOCK *pdelayblock);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralSendToPhone(UINT16 U16baseport, UINT8 *pAU8buffer, UINT32 U32size, UINT32 U32cmd, tFLS1_DELAYBLOCK *pdelayblock);
typedef BOOL (*pGeneralSendToPhone)(UINT16 U16baseport, UINT8 *pAU8buffer, UINT32 U32size, UINT32 U32cmd, tFLS1_DELAYBLOCK *pdelayblock);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SendToPhone(UINT8 *pAU8buffer, UINT32 U32size, UINT32 U32cmd, tFLS1_DELAYBLOCK *pdelayblock);
typedef BOOL (*pSendToPhone)(UINT8 *pAU8buffer, UINT32 U32size, UINT32 U32cmd, tFLS1_DELAYBLOCK *pdelayblock);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralInitialiseBootstrapDCT3(UINT16 U16baseport,UINT8 *pAU8buffer, UINT16 U16size, UINT32 U32retrycount);
typedef BOOL (*pGeneralInitialiseBootstrapDCT3)(UINT16 U16baseport,UINT8 *pAU8buffer, UINT16 U16size, UINT32 U32retrycount);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_InitialiseBootstrapDCT3(UINT8 *pAU8buffer, UINT16 U16size, UINT32 U32retrycount);
typedef BOOL (*pInitialiseBootstrapDCT3)(UINT8 *pAU8buffer, UINT16 U16size, UINT32 U32retrycount);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_GeneralInitialiseBootstrapDCT4(UINT16 U16baseport, UINT8 *pAU8buffer, UINT16 U16size, UINT32 *pU32mcuresponse);
typedef BOOL (*pGeneralInitialiseBootstrapDCT4)(UINT16 U16baseport, UINT8 *pAU8buffer, UINT16 U16size, UINT32 *pU32mcuresponse);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_InitialiseBootstrapDCT4(UINT8 *pAU8buffer, UINT16 U16size, UINT32 *pU32mcuresponse);
typedef BOOL (*pInitialiseBootstrapDCT4)(UINT8 *pAU8buffer, UINT16 U16size, UINT32 *pU32mcuresponse);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_MBUSSecurityCommand(const tMBUSCMD *mbuscmd,UINT8 *pU8reply, UINT32 U32replybuffersize, UINT32 *pU32replysize);
typedef BOOL (*pMBUSSecurityCommand)(const tMBUSCMD *mbuscmd,UINT8 *pU8reply, UINT32 U32replybuffersize, UINT32 *pU32replysize);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetLogCallout(pLogCallout logcallout);
typedef void (*pSetLogCallout)(pLogCallout logcallout);

__IMPORT_TYPE eDEVICE_STATE __EXPORT_TYPE FLS1_GetDeviceState(void);
typedef eDEVICE_STATE (*pGetDeviceState)(void);

__IMPORT_TYPE eFLASH_ERROR __EXPORT_TYPE FLS1_GetErrno(void);
typedef eFLASH_ERROR (*pGetErrno)(void);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_GetStatus(tFLASH_STATUS *pstatus);
typedef void (*pGetStatus)(tFLASH_STATUS *pstatus);

/*
__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetRdtscDelay(void);
typedef void (*pSetRdtscDelay)(void);
__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetLoopDelay(void);
typedef void (*pSetLoopDelay)(void);
*/

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetBaseDelay(UINT32 U32delay);
typedef void (*pSetBaseDelay)(UINT32 U32delay);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetFlashIDList(char *name);
typedef void (*pSetFlashIDList)(char *name);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetAlgoCodeExtension(char *ext);
typedef void (*pSetAlgoCodeExtension)(char *ext);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetAliasIDList(char *ext);
typedef void (*pSetAliasIDList)(char *ext);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetModelsList(char *ext);
typedef void (*pSetModelsList)(char *ext);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ReadFullFlash(char *flashfilename, BOOL Bbinary);
typedef BOOL (*pReadFullFlash)(char *flashfilename, BOOL Bbinary);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetAlgoCodeList(char *name);
typedef void (*pSetAlgoCodeList)(char *name);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_DummyWrite(void);
typedef BOOL (*pDummyWrite)(void);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetGaugeUpdate(pGaugeUpdate gaugeupdate);
typedef void (*pSetGaugeUpdate)(pGaugeUpdate gaugeupdate);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetGaugeInit(pGaugeInit gaugeinit);
typedef void (*pSetGaugeInit)(pGaugeInit gaugeinit);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetGaugeDone(pGaugeDone gaugedone);
typedef void (*pSetGaugeDone)(pGaugeDone gaugedone);

__IMPORT_TYPE void __EXPORT_TYPE FLS1_SetSafeFlashing(BOOL Bsafeflash);
typedef void (*pSetSafeFlashing)(BOOL Bsafeflash);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ResetSettings(eMBUS_RESET_TYPE reset_type);
typedef BOOL (*pResetSettings)(eMBUS_RESET_TYPE reset_type);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ResetPhone(void);
typedef BOOL (*pResetPhone)(void);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SetSimlock(UINT8 U8lockidx,char *val,BOOL Bopen);
typedef BOOL (*pSetSimlock)(UINT8 U8lockidx,char *val,BOOL Bopen);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ConvertToKNK(char *filename,UINT32 U32startaddr);
typedef BOOL (*pConvertToKNK)(char *filename,UINT32 U32startaddr);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SetContrast(UINT8 U8val);
typedef BOOL (*pSetContrast)(UINT8 U8val);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SetFAID(UINT32 U32fchk);
typedef BOOL (*pSetFAID)(UINT32 U32fchk);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ConvertWTFilesToFLSKNK(char *mcufile,char *ppmfile,BOOL BtoKNK);
typedef BOOL (*pConvertWTFilesToFLSKNK)(char *mcufile,char *ppmfile,BOOL BtoKNK);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_ResetSPlock(void);
typedef BOOL (*pResetSPlock)(void);

__IMPORT_TYPE BOOL __EXPORT_TYPE FLS1_SetIMEI(UINT8 *newIMEI);
typedef BOOL (*pSetIMEI)(UINT8 *newIMEI);

#endif
