
/********************************************************************
* NAME:                                                             *
*                                                                   *
* PURPOSE:                                                          *
*                                                                   *
* GLOBAL VARIABLES:                                                 *
*                                                                   *
* Variable:                                                         *
*                                                                   *
* Type:                                                             *
*                                                                   *
* Description:                                                      *
*                                                                   *
*                                                                   *
* DEVELOPMENT HISTORY:                                              *
*                                                                   *
* Date:                                                             *
*                                                                   *
* Author:                                                           *
*                                                                   *
* Change Id:                                                        *
*                                                                   *
* Release:                                                          *
*                                                                   *
* Description of change:                                            *
*                                                                   *
*********************************************************************/


#ifndef __fle5_loc_h
#define __fle5_loc_h

#define BTEMP_BIT 4
#define BTEMP_BIT_MASK (UINT8)(1<<BTEMP_BIT)

#define BTEMPLOW(x) ((x) |= BTEMP_BIT_MASK)
#define BTEMPHIGH(x) ((x) &= (UINT8)~BTEMP_BIT_MASK)

#define SCL_IN_BIT 3
#define SCL_IN_BIT_MASK (UINT8)(1<<SCL_IN_BIT)

#define SCL_OUT_BIT 0
#define SCL_OUT_BIT_MASK (UINT8)(1<<SCL_OUT_BIT)

#define SCLLOW(x) ((x) |= SCL_OUT_BIT_MASK)
#define SCLHIGH(x) ((x) &= (UINT8)~SCL_OUT_BIT_MASK)

#define SDA_IN_BIT 7
#define SDA_IN_BIT_MASK (UINT8)(1<<SDA_IN_BIT)

#define SDA_OUT_BIT 2
#define SDA_OUT_BIT_MASK (UINT8)(1<<SDA_OUT_BIT)

#define SDALOW(x) ((x) |= SDA_OUT_BIT_MASK)
#define SDAHIGH(x) ((x) &= (UINT8)~SDA_OUT_BIT_MASK)

#define XXX_OUT_BIT 3
#define XXX_OUT_BIT_MASK (UINT8)(1<<XXX_OUT_BIT)

#define XXXHIGH(x) ((x) |= XXX_OUT_BIT_MASK)
#define XXXLOW(x) ((x) &= (UINT8)~XXX_OUT_BIT_MASK)

#define VPP_OUT1_BIT 1
#define VPP_OUT1_BIT_MASK (UINT8)(1<<VPP_OUT1_BIT)
#define VPP_OUT2_BIT 3
#define VPP_OUT2_BIT_MASK (UINT8)(1<<VPP_OUT2_BIT)
#define VPP_OUT_BIT_MASK (VPP_OUT1_BIT_MASK | VPP_OUT2_BIT_MASK)

#define VPPHIGH(x) ((x) |= VPP_OUT_BIT_MASK)
#define VPPLOW(x) ((x) &= (UINT8)~VPP_OUT_BIT_MASK)

#define FLE5_AFTER_WRITE_DELAY 0x02
#define FLE5_AFTER_WRITE_CHECK_SDA 0x08
#define FLE5_AFTER_WRITE_WAIT_FOR_SDA 0x04
#define FLE5_AFTER_WRITE_FINAL_DELAY 0x80
#define FLE5_AFTER_READ_EXTRADELAY 0x01
#define FLE5_WRITE_TYPE_MODE 0xB00
#define FLE5_DIRECT_STRANGE_WRITE2 0x100

#define FLE5_DIRECT_IDLE_MODE1 64
#define FLE5_DIRECT_IDLE_MODE2 16

#define FLE5_INITTESTMODE_DCT4 0x93
#define FLE5_EXECUTECMD 0x00

#define FLE5_MAJIC_NUMBER 1374389535L
#define FLE5_EXECUTE_CMD 0x70
#define FLE5_DELAY_AFTER_READWRITE 0x80

#define FLE5_WAITFOREDGE_LOW 0x10
#define FLE5_WAITFOREDGE_HIGH 0x20
#define FLE5_EXECUTESTREAM 0x40

#endif
